sc::DistSymmSCMatrix Class Reference
Inheritance diagram for sc::DistSymmSCMatrix:
[legend]
Collaboration diagram for sc::DistSymmSCMatrix:
[legend]

## Public Member Functions

| DistSymmSCMatrix (const RefSCDimension &, DistSCMatrixKit *)
double | get_element (int, int) const
| Return or modify an element.
void | set_element (int, int, double)
void | accumulate_element (int, int, double)
SCMatrix * | get_subblock (int, int, int, int)
| Return a subblock of this. More...
SymmSCMatrix * | get_subblock (int, int)
void | assign_subblock (SCMatrix *, int, int, int, int)
| Assign m to a subblock of this.
void | assign_subblock (SymmSCMatrix *, int, int)
void | accumulate_subblock (SCMatrix *, int, int, int, int)
| Sum m into a subblock of this.
void | accumulate_subblock (SymmSCMatrix *, int, int)
SCVector * | get_row (int i)
| Return a row of this.
void | assign_row (SCVector *v, int i)
| Assign v to a row of this.
void | accumulate_row (SCVector *v, int i)
| Sum v to a row of this.
void | accumulate_product_rr (SCMatrix *, SCMatrix *)
void | accumulate (const SymmSCMatrix *)
| Sum m into this.
double | invert_this ()
| Invert this.
double | solve_this (SCVector *)
double | trace ()
| Return the trace.
double | determ_this ()
| Return the determinant of this. this is overwritten.
void | gen_invert_this ()
void | diagonalize (DiagSCMatrix *, SCMatrix *)
| Diagonalize this, placing the eigenvalues in d and the eigenvectors in m. More...
void | accumulate_symmetric_sum (SCMatrix *)
| Sum into this the products of various vectors or matrices.
void | element_op (const Ref< SCElementOp > &)
| Perform the element operation op on each element of this.
void | element_op (const Ref< SCElementOp2 > &, SymmSCMatrix *)
void | element_op (const Ref< SCElementOp3 > &, SymmSCMatrix *, SymmSCMatrix *)
virtual void | convert_accumulate (SymmSCMatrix *)
Ref< SCMatrixSubblockIter > | local_blocks (SCMatrixSubblockIter::Access)
| Returns iterators for the local (rapidly accessible) blocks used in this matrix. More...
Ref< SCMatrixSubblockIter > | all_blocks (SCMatrixSubblockIter::Access)
| Returns iterators for the all blocks used in this matrix.
Ref< DistSCMatrixKit > | skit ()
Public Member Functions inherited from sc::SymmSCMatrix
| SymmSCMatrix (const RefSCDimension &, SCMatrixKit *)
Ref< SCMatrixKit > | kit () const
| Return the SCMatrixKit object that created this object.
virtual void | save (StateOut &)
| Save and restore this in an implementation independent way.
virtual void | restore (StateIn &)
virtual double | maxabs () const
| Return the maximum absolute value element of this vector.
virtual void | randomize ()
| Assign each element to a random number between -1 and 1.
void | assign (double val)
| Set all elements to val.
void | assign (const double *m)
| Assign element i, j to m[i*(i+1)/2+j]. More...
void | assign (const double **m)
| Assign element i, j to m[i][j].
void | assign (SymmSCMatrix *m)
| Make this have the same elements as m. More...
virtual void | assign_val (double val)
| Overridden to implement the assign functions.
virtual void | assign_p (const double *m)
virtual void | assign_pp (const double **m)
virtual void | assign_s (SymmSCMatrix *m)
virtual void | convert (double *) const
| Like the assign members, but these write values to the arguments.
virtual void | convert (double **) const
virtual void | convert (SymmSCMatrix *)
| Convert an SCSymmSCMatrix of a different specialization to this specialization and possibly accumulate the data. More...
virtual void | scale (double)
| Multiply all elements by val.
virtual void | scale_diagonal (double)
| Scale the diagonal elements by val.
virtual void | shift_diagonal (double)
| Shift the diagonal elements by val.
virtual void | unit ()
| Make this equal to the unit matrix.
int | n () const
| Return the dimension.
virtual SymmSCMatrix * | copy ()
| Return a matrix with the same dimension and same elements.
virtual SymmSCMatrix * | clone ()
| Return a matrix with the same dimension but uninitialized memory.
RefSCDimension | dim () const
| Return the dimension.
virtual void | accumulate_symmetric_product (SCMatrix *)
virtual void | accumulate_transform (SCMatrix *, SymmSCMatrix *, SCMatrix::Transform=SCMatrix::NormalTransform)
virtual void | accumulate_transform (SCMatrix *, DiagSCMatrix *, SCMatrix::Transform=SCMatrix::NormalTransform)
virtual void | accumulate_transform (SymmSCMatrix *, SymmSCMatrix *)
virtual void | accumulate_symmetric_outer_product (SCVector *)
virtual double | scalar_product (SCVector *v)
| Return the scalar obtained by multiplying this on the left and right by v. More...
void | print (std::ostream &o=ExEnv::out0()) const
| Print out the matrix.
void | print (const char *title=0, std::ostream &out=ExEnv::out0(), int=10) const
virtual void | vprint (const char *title=0, std::ostream &out=ExEnv::out0(), int=10) const
Ref< MessageGrp > | messagegrp () const
| Returns the message group used by the matrix kit.
Public Member Functions inherited from sc::DescribedClass
| DescribedClass (const DescribedClass &)
DescribedClass & | operator= (const DescribedClass &)
ClassDesc * | class_desc () const throw ()
| This returns the unique pointer to the ClassDesc corresponding to the given type_info object. More...
const char * | class_name () const
| Return the name of the object's exact type.
int | class_version () const
| Return the version of the class.
Public Member Functions inherited from sc::RefCount
int | lock_ptr () const
| Lock this object.
int | unlock_ptr () const
| Unlock this object.
void | use_locks (bool inVal)
| start and stop using locks on this object
refcount_t | nreference () const
| Return the reference count.
refcount_t | reference ()
| Increment the reference count and return the new count.
refcount_t | dereference ()
| Decrement the reference count and return the new count.
int | managed () const
void | unmanage ()
| Turn off the reference counting mechanism for this object. More...
int | managed () const
| Return 1 if the object is managed. Otherwise return 0.
Public Member Functions inherited from sc::Identity
Identifier | identifier ()
| Return the Identifier for this argument. More...

## Protected Member Functions

void | init_blocklist ()
double * | find_element (int i, int j) const
int | element_to_node (int i, int j) const
int | block_to_node (int, int) const
Ref< SCMatrixBlock > | block_to_block (int, int) const
void | error (const char *msg)

## Protected Attributes

Ref< SCMatrixBlockList > | blocklist
Protected Attributes inherited from sc::SymmSCMatrix
RefSCDimension | d
Ref< SCMatrixKit > | kit_

## Friends

class | DistSCMatrix
class | DistDiagSCMatrix
class | DistSCVector

## Member Function Documentation

void sc::DistSymmSCMatrix::diagonalize | ( | DiagSCMatrix * | d,
|  | SCMatrix * | m
| ) |  |

virtual

Diagonalize this, placing the eigenvalues in d and the eigenvectors in m.

Implements sc::SymmSCMatrix.

SCMatrix* sc::DistSymmSCMatrix::get_subblock | ( | int | br,
|  | int | er,
|  | int | bc,
|  | int | ec
| ) |  |

virtual

Return a subblock of this.

The subblock is defined as the rows starting at br and ending at er, and the columns beginning at bc and ending at ec.

Implements sc::SymmSCMatrix.

Ref<SCMatrixSubblockIter> sc::DistSymmSCMatrix::local_blocks | ( | SCMatrixSubblockIter::Access |  | ) |

virtual

Returns iterators for the local (rapidly accessible) blocks used in this matrix.

Implements sc::SymmSCMatrix.

The documentation for this class was generated from the following file:

- dist.h